/**
 * 
 */
package org.padict.pdb;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;

/**
 * @author Benoit Cerrina
 *
 */
public class HotlistBatchImport
{

	/**
	 * @param args
	 */
	public static void main(String[] iArgs)
	{
		LineNumberReader lInputHL = null;
		PdbFile lOutputPDB = new PdbFile();
		for (int lCurArg = 0; lCurArg < iArgs.length; lCurArg++ )
		{
			if (iArgs[lCurArg].equals("-h"))
			{
				System.out.println("-h this message\n-i InputFile\n -o OutputPdb");
				continue;
			}
			if (iArgs[lCurArg].equals("-i"))
			{
				if (++lCurArg == iArgs.length)
				{
					System.out.println("missing input file name");
					continue;
				}
				try
				{
					lInputHL = new LineNumberReader(new FileReader(iArgs[lCurArg]));
				
				} catch (FileNotFoundException lCurException)
				{
					System.err.println("File " + iArgs[lCurArg] + " was not found");
					return;
				}
			}
			if (iArgs[lCurArg].equals("-o"))
			{
				if (++lCurArg == iArgs.length)
				{
					System.out.println("missing output file name");
					continue;
				}
				File lWorkingFile = new File(iArgs[lCurArg]);
				lOutputPDB.setWorkingFile(lWorkingFile);
				//TODO need to check the length of the name
				lOutputPDB.setAttributes(new boolean[16]);
				lOutputPDB.setDatabaseName(lWorkingFile.getName());
				lOutputPDB.setCreatorName("LGWS");
				lOutputPDB.setTypeName("Voca");
				lOutputPDB.setVersion(1);
			}
		}
		if(lInputHL != null)
		{
			try
			{
				StringBuffer lCurRecordData = new StringBuffer();
				PdbRecord lCurRecord = new PdbRecord("".getBytes(), (byte) 0, 0);
				int lCurLineNumber = 0;
				for (String lCurLine = lInputHL.readLine(); lCurLine != null; lCurLine = lInputHL.readLine())
				{
					lCurLineNumber = lInputHL.getLineNumber(); 
					if (lCurLineNumber % 50 == 0)
					{
						if (lCurRecord != null)
						{
							lCurRecord.setData(lCurRecordData.toString());
							lOutputPDB.getRecords().add(lCurRecord);
						}
						lCurRecord = new PdbRecord("".getBytes(), (byte) 0, lCurLineNumber / 50);
						lCurRecordData = new StringBuffer();
					}
					lCurRecordData.append(lCurLine).append("\n");
				}
				if (lCurLineNumber % 50 != 0)
				{
					
				//lCurRecord = new PdbRecord("".getBytes(), (byte) 0, lCurLineNumber / 50);
				lCurRecord.setData(lCurRecordData.toString());
				lOutputPDB.getRecords().add(lCurRecord);
				}
				
				lOutputPDB.save();
			} catch (IOException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return;
		
	}

}
